--
-- multilonger
--
-- M@D Author  Headshot XXL
-- M@D date  
--
-- > Copyright (C) Headshot XXL - www.planet-ls.de < --


multilonger = {}

function multilonger.prerequisitesPresent(specializations)
	
  return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function multilonger:load(xmlFile)        
	self.setCilindroDirection = SpecializationUtil.callSpecializationsFunction("setCilindroDirection");	
	local cilindrosCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cilindros#count"), 0);	
	self.cilindros = {};	
	for i=1, cilindrosCount do
		local cilindroName = string.format("vehicle.cilindros.cilindro%d", i);		
		self.cilindros[i] = {};		
		self.cilindros[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#index"));
		self.cilindros[i].part = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#part"));
		self.cilindros[i].cilindroFixpoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#cilindroFixpoint"));
		self.cilindros[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#fixpoint"));
		local ax, ay, az = getWorldTranslation(self.cilindros[i].part);
		local bx, by, bz = getWorldTranslation(self.cilindros[i].cilindroFixpoint);		
		self.cilindros[i].partDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);	
	end;	
		self.setCilindrooDirection = SpecializationUtil.callSpecializationsFunction("setCilindrooDirection");	
	local cilindrossCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cilindross#count"), 0);	
	self.cilindross = {};	
	for i=1, cilindrossCount do
		local cilindrooName = string.format("vehicle.cilindross.cilindroo%d", i);		
		self.cilindross[i] = {};		
		self.cilindross[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindrooName .. "#index"));
		self.cilindross[i].part = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindrooName .. "#part"));
		self.cilindross[i].cilindrooFixpoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindrooName .. "#cilindrooFixpoint"));
		self.cilindross[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindrooName .. "#fixpoint"));
		local cx, cy, cz = getWorldTranslation(self.cilindross[i].part);
		local dx, dy, dz = getWorldTranslation(self.cilindross[i].cilindrooFixpoint);		
		self.cilindross[i].partDistance = Utils.vector3Length(cx-dx, cy-dy, cz-dz);	
	end;	
   local translationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation1#index"));
    if translationNode1 ~= nil then
        self.translation1 = {};
        self.translation1.node = translationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#minTrans"));
        self.translation1.minTrans = {};
        self.translation1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation1#maxTrans"));
        self.translation1.maxTrans = {};
        self.translation1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation1.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation1#transTime"), 2)*1000;
      
    end;
		local translationNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation2#index"));
    if translationNode2 ~= nil then
        self.translation2 = {};
        self.translation2.node = translationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#minTrans"));
        self.translation2.minTrans = {};
        self.translation2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#maxTrans"));
        self.translation2.maxTrans = {};
        self.translation2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#transTime"), 2)*1000;
      
    end;
		local translationNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translation3#index"));
    if translationNode3 ~= nil then
        self.translation3 = {};
        self.translation3.node = translationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#minTrans"));
        self.translation3.minTrans = {};
        self.translation3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#maxTrans"));
        self.translation3.maxTrans = {};
        self.translation3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.maxTrans[3] = Utils.getNoNil(z, 0);

	

        self.translation3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#transTime"), 2)*1000;
      
    end;
	local rotationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
      
    end;
	
	
    local rotationNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
     
    end;
	
	 local rotationNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
      
    end;
	
	 local rotationNode7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation7#index"));
    if rotationNode7 ~= nil then
        self.rotation7 = {};
        self.rotation7.node = rotationNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#minRot"));
        self.rotation7.minRot = {};
        self.rotation7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#maxRot"));
        self.rotation7.maxRot = {};
        self.rotation7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#rotTime"), 2)*1000;
     
    end;
	 local rotationNode8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation8#index"));
    if rotationNode8 ~= nil then
        self.rotation8 = {};
        self.rotation8.node = rotationNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#minRot"));
        self.rotation8.minRot = {};
        self.rotation8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#maxRot"));
        self.rotation8.maxRot = {};
        self.rotation8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

          self.rotation8.rotTime = self.rotation7.rotTime;
      
    end;
	 local rotationNode9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation9#index"));
    if rotationNode9 ~= nil then
        self.rotation9 = {};
        self.rotation9.node = rotationNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#minRot"));
        self.rotation9.minRot = {};
        self.rotation9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#maxRot"));
        self.rotation9.maxRot = {};
        self.rotation9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

          self.rotation9.rotTime = self.rotation7.rotTime;
     
    end;

	
		local mowerSound = getXMLString(xmlFile, "vehicle.mowerSound#file");
    if mowerSound ~= nil and mowerSound ~= "" then
        mowerSound = Utils.getFilename(mowerSound, self.baseDirectory); 
        self.mowerSound = createSample("mowerSound");
        self.mowerSoundEnabled = false;
        loadSample(self.mowerSound, mowerSound, false);
        self.mowerSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#pitchOffset"), 1);
        self.mowerSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#volume"), 1);
    end;
	 local hidraulicSound = getXMLString(xmlFile, "vehicle.hidraulicSound#file");
    if hidraulicSound ~= nil and hidraulicSound ~= "" then
        hidraulicSound = Utils.getFilename(hidraulicSound, self.baseDirectory); 
        self.hidraulicSound = createSample("hidraulicSound");
        loadSample(self.hidraulicSound, hidraulicSound, false);
        self.hidraulicSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchOffset"), 1);
        self.hidraulicSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchScale"), 0);
        self.hidraulicSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchMax"), 2.0);
    end;
self.particleSystems = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.particleSystems.particleSystems(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		if nodei == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.particleSystems, namei, nodei, false, nil, self.baseDirectory)		
		i = i +1;		
    end;
self.drumNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index"));
 self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);
 
		self.dustParticleSystems = {};
    local dustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dustParticleSystems#count"), 0);
    for i=1, dustParticleSystemCount do
        local namei = string.format("vehicle.dustParticleSystems.part%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.dustParticleSystems, namei, nodei, false, nil, self.baseDirectory)			
    end;
	self.controlpath = Utils.getFilename("multilonger.jpg", self.baseDirectory);
   
    self.hudmultilongerPoxX = 0.01;
    self.hudmultilongerPoxY = 1-0.204;
    self.hudmultilongerWidth = 0.240;
    self.hudmultilongerHeight = 0.240;
    self.hudmultilongerPoxX = 0.75;
    self.hudmultilongerPoxY = 0.60
    self.hudmultilongerOverlay = Overlay:new("hudmultilonger", self.controlpath, self.hudmultilongerPoxX, self.hudmultilongerPoxY, self.hudmultilongerWidth, self.hudmultilongerHeight);
     self.bcActive = false;
	self.groundCheck = {};
	self.groundCheck = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundCheck#index"));
	
	
end;
      
function multilonger:delete()  
Utils.setEmittingState(self.particleSystems,false)  
 if self.mowerSoundEnabled then
       stopSample(self.mowerSound);
        self.mowerSoundEnabled = false;
    end;
	 if self.hidraulicSound ~= nil then
        delete(self.hidraulicSound);
    end;
end;

function multilonger:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function multilonger:keyEvent(unicode, sym, modifier, isDown)
   if isDown and sym == 48 then -- Key:0
		self.bcActive = not self.bcActive;
    end;
   
	if sym == Input.KEY_KP_3 then
		self.rotation1Max = isDown;
	
		self.playHidraulic = not self.playHidraulic;
	end;
	if sym == Input.KEY_KP_1 then
		self.rotation1Min = isDown;
	
		self.playHidraulic1 = not self.playHidraulic1;
	end;
	if sym == Input.KEY_KP_4 then
		self.rotation3Max = isDown;
	
		
		self.playHidraulic2 = not self.playHidraulic2;
	
	end;
	if sym == Input.KEY_KP_6 then
		self.rotation3Min = isDown;
		
		
		
		self.playHidraulic3 = not self.playHidraulic3;
	
	end;
	if sym == Input.KEY_KP_7 then
		self.rotation5Max = isDown;
	
		
		self.playHidraulic4 = not self.playHidraulic4;
	
	end;
	if sym == Input.KEY_KP_9 then
		self.rotation5Min = isDown;
	
	
		self.playHidraulic5 = not self.playHidraulic5;
		
	end;
	if sym == Input.KEY_KP_8 then
		self.rotation7Max = isDown;
		self.rotation8Max = isDown;
		self.rotation9Max = isDown;
		
		self.playHidraulic6 = not self.playHidraulic6;
	end;
	if sym == Input.KEY_KP_2 then
		self.rotation7Min = isDown;
		self.rotation8Min = isDown;
		self.rotation9Min = isDown;
		
		self.playHidraulic7 = not self.playHidraulic7;
	end;
	if isDown and sym == Input.KEY_b   then
		self.isTurnedOn = not self.isTurnedOn;
	end;
end;

function multilonger:update(dt)
	if self.fixAttacher then
			local implement = self.attacherVehicle:getImplementByObject(self);
			if implement ~= nil then
				local joint = self.attacherVehicle.attacherJoints[implement.jointDescIndex];
				self.saveJoint = self.attacherVehicle.attacherJoints[implement.jointDescIndex];
				self.maxRotJoint = joint.maxRotLimit;
				self.attacherJointIndex = implement.jointDescIndex;
				self.rotationCopy  = joint.minRot;
				joint.minRot = {Utils.degToRad(2),0,0};			
				joint.maxRotLimit = {0, 0, 0};
				setJointRotationLimit(joint.jointIndex, 2, true, 0, 0);
			end;
			self.fixAttacher = false;
		end;
	if self.attacherVehicle then
	self:setCilindroDirection();	
	self:setCilindrooDirection();
	
	if self.isTurnedOn then	
			
			local x,y,z = getWorldTranslation(self.groundCheck);
			local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			local gC = y-terrainHeight; 
		
			if (math.min(gC) < 0.5) then
			self.go = true;
			else
			self.go = false;
			end;	
			
	if  self.go	  then
		Utils.setEmittingState(self.dustParticleSystems, true)
			Utils.setEmittingState(self.particleSystems, true);
	else
			Utils.setEmittingState(self.particleSystems, false);
			Utils.setEmittingState(self.dustParticleSystems, false)
			end;
		
			
	if self.drumNode1 ~= nil then
				rotate(self.drumNode1, self.drumRotationScale * 20 * 1, 0, 0);
			end;
			if self.go then
		if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				Utils.cutFruitArea( 1, x1, z2, x1, z1, x2, z2);
				Utils.cutFruitArea( 2, x1, z2, x1, z1, x2, z2);
				Utils.cutFruitArea( 3, x1, z2, x1, z1, x2, z2);
				Utils.cutFruitArea( 4, x1, z2, x1, z1, x2, z2);
				Utils.updateMeadowArea(x1, z2, x1, z1, x2, z2);
				Utils.updateCuttedMeadowArea(x1, z2, x1, z1, x2, z2);
				end;
				end;
		if not self.mowerSoundRunning then
                print("start");
                playSample(self.mowerSound, 0, 1.6, 0);
                self.mowerSoundRunning = true;
				
			end;	
	else
	
	if self.mowerSoundRunning then
                print("end");
                stopSample(self.mowerSound, 0, 1.6, 0);
                self.mowerSoundRunning = false;
		
	 end;	
	end;	
end;
	if (not self.isTurnedOn) then	
		Utils.setEmittingState(self.particleSystems, false);
			Utils.setEmittingState(self.dustParticleSystems, false)
	end;
	if self.playHidraulic or self.playHidraulic1 or self.playHidraulic2 or self.playHidraulic3 or self.playHidraulic4 or self.playHidraulic5 or self.playHidraulic6 or self.playHidraulic7 then
            if self.hidraulicSound ~= nil and not self.hidraulicSoundEnabled then
                if self:getIsActiveForSound() then
                    setSamplePitch(self.hidraulicSound, self.hidraulicSoundPitchOffset);
                    playSample(self.hidraulicSound, 0, 0.5, 0);
                    self.hidraulicSoundEnabled = true;
                end;
            end;
     
		
     else
            if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
                stopSample(self.hidraulicSound);
                self.hidraulicSoundEnabled = false;
            end;
     
	end;
	

	
	
	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	

    local doRotate = self.rotation3Max or self.rotation3Min 
	if self.rotation3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
    end;
	
	 local doRotate = self.rotation5Max or self.rotation5Min 
	if self.rotation5 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
        setRotation(self.rotation5.node, unpack(newRot));
    end;
	
	 local doRotate = self.rotation7Max or self.rotation7Min 
	if self.rotation7 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation7.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation7.maxRot, self.rotation7.minRot, 3, self.rotation7.rotTime, dt, not self.rotation7Max);
        setRotation(self.rotation7.node, unpack(newRot));
    end;
	 local doRotate = self.rotation8Max or self.rotation8Min 
	if self.rotation8 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation8.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation8.maxRot, self.rotation8.minRot, 3, self.rotation8.rotTime, dt, not self.rotation8Max);
        setRotation(self.rotation8.node, unpack(newRot));
    end;
	 local doRotate = self.rotation9Max or self.rotation9Min 
	if self.rotation9 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation9.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation9.maxRot, self.rotation9.minRot, 3, self.rotation9.rotTime, dt, not self.rotation9Max);
        setRotation(self.rotation9.node, unpack(newRot));
    end;
	if self.translation1Max ~= nil then
		local x, y, z = getTranslation(self.translation1.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translation1.maxTrans, self.translation1.minTrans, 3, self.translation1.transTime, dt, not self.translation1Max);
        setTranslation(self.translation1.node, unpack(newTrans));
		end;	
if self.translation2Max ~= nil then
		local x, y, z = getTranslation(self.translation2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translation2Max);
        setTranslation(self.translation2.node, unpack(newTrans));
		end;
		if self.translation3Max ~= nil then
		local x, y, z = getTranslation(self.translation3.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translation3.maxTrans, self.translation3.minTrans, 3, self.translation3.transTime, dt, not self.translation3Max);
        setTranslation(self.translation3.node, unpack(newTrans));
		end;
	local joint = self.componentJoints[1];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[2];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[3];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[4];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[5];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
end;

function multilonger:draw()
	 if self.hudmultilongerOverlay ~= nil then
  if self.bcActive then
    self.hudmultilongerOverlay:render();
  end;
end;
		if self.bcActive then	
			g_currentMission:addExtraPrintText("Info 0: menu On");
		else
			g_currentMission:addExtraPrintText("Info 0: menu Off");
		end;
end;

function multilonger:onAttach()	
	
	self.fixAttacher = true; 
	self.translation1Max = true;
		self.translation2Max = true;
		self.translation3Max = true;
end;
function multilonger:onDeactivateSounds()
    if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
        stopSample(self.hidraulicSound);
        self.hidraulicSoundEnabled = false;
    end;
   if self.mowerSoundRunning then
                print("end");
                stopSample(self.mowerSound, 0, 1.6, 0);
                self.mowerSoundRunning = false;
			end;
end;
function multilonger:onDetach() 
self.translation1Max = false;
		self.translation2Max = false;  
		self.translation3Max = false;  
	self.isTurnedOn = false;
	 stopSample(self.mowerSound);
        self.mowerSoundEnabled = false;
	local joint = self.saveJoint; 
	joint.minRot = self.rotationCopy;
	joint.maxRotLimit = self.maxRotJoint;
end;
function multilonger:setCilindroDirection()
	for i=1, table.getn(self.cilindros) do
		local ax, ay, az = getWorldTranslation(self.cilindros[i].node);
		local bx, by, bz = getWorldTranslation(self.cilindros[i].fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.cilindros[i].node), bx-ax, by-ay, bz-az);
		
		setDirection(self.cilindros[i].node, x, y, z, 0, 1, 0);
		if self.cilindros[i].part ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
				setTranslation(self.cilindros[i].part, distance-self.cilindros[i].partDistance ,0 ,0 );
		end;	
	end;
end;
function multilonger:setCilindrooDirection()
	for i=1, table.getn(self.cilindross) do
		local cx, cy, cz = getWorldTranslation(self.cilindross[i].node);
		local dx, dy, dz = getWorldTranslation(self.cilindross[i].fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.cilindross[i].node), dx-cx, dy-cy, dz-cz);
		
		setDirection(self.cilindross[i].node, x, y, z, 0, 1, 0);
		if self.cilindross[i].part ~= nil then
			local distance = Utils.vector3Length(cx-dx, cy-dy, cz-dz);
				setTranslation(self.cilindross[i].part,0 ,0 ,distance-self.cilindross[i].partDistance);
		end;	
	end;
end;